/**********************************************************************
  Pass|Cg̐ݒ
  ʉߓ_w肵Aʂꍇ̓bZ[Wo͂
  $Id: pp_cmd.c,v 1.5 2002/11/03 03:57:36 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"

int	pp_cmd( struct TOKEN_STRUCT *tk_pt , int mode )
{
int i,j ;
int id ; 
unsigned char *label ; 
  
  if( tk_pt->pt[1]==NULL ){
    for( i=0 ; i<MAX_PROCESS_ID ; i++ ){
      if( proc_list.proc[i].pp_num>0 ){
	SYSMSG("--- Pass Point(s) for Process ID = %2d --\n",i) ;
	for( j=0 ; j<proc_list.proc[i].pp_num ; j++ ){
	  SYSMSG("No.%02d : 0x%08x %s\n",
		 proc_list.proc[i].pp[j].id,
		 proc_list.proc[i].pp[j].ad,
		 proc_list.proc[i].pp[j].label) ;
	}
      }
    }
    return(NORMAL_EXIT) ;
  }
  if( tk_pt->pt[2]==NULL ){
    id=proc_list.cur_id ;
  }else{
    if( tk_pt->pt[2][0]=='+' ){
      id=proc_list.cur_id+1 ;
    }else if( tk_pt->pt[2][0]=='-' ){
      id=proc_list.cur_id-1 ;
    }else if( tk_pt->pt[2][0]=='=' ){
      id=proc_list.cur_id ;
    }else{
      id=exatoi(tk_pt->pt[2]) ;
    }
    if( id>=MAX_PROCESS_ID || id<0 ){
      SYSMSG("Invalid Process ID (Min=0,Max=%d specify=%d).\n",
	     (MAX_PROCESS_ID)-1,id) ;
      return(NORMAL_EXIT) ;
    }
  }
  if( tk_pt->pt[3]!=NULL ){
    label=malloc( strlen(tk_pt->pt[3])+1 ) ;
    strcpy(label,tk_pt->pt[3]) ;
  }else{
    label=malloc( 1 ) ;
    label[0]='\0' ;
  }

  if( proc_list.proc[id].pp_num==MAX_PASS_POINT_NUM ){
    SYSMSG("Pass Point Buffer is full.\n") ;
    return(NORMAL_EXIT) ;
  }
  
  proc_list.proc[id].pp[proc_list.proc[id].pp_num].ad = exatoi(tk_pt->pt[1]) ;
  proc_list.proc[id].pp[proc_list.proc[id].pp_num].id = proc_list.proc[id].pp_id++ ;
  proc_list.proc[id].pp[proc_list.proc[id].pp_num].label=label ;
  SYSMSG("Setting pp=0x%08x , BPID=%d , label=%s , PID=%d\n",
	 proc_list.proc[id].pp[proc_list.proc[id].pp_num].ad,
	 proc_list.proc[id].pp[proc_list.proc[id].pp_num].id,
	 proc_list.proc[id].pp[proc_list.proc[id].pp_num].label,
	 id) ;
  proc_list.proc[id].pp_num++ ;
  return(NORMAL_EXIT) ;

}


