/**********************************************************************
  execve G~[V
  $Id: sim_execve.c,v 1.2 2002/11/11 17:47:41 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"

int	sim_execve( struct MACHINE_RESOURCE *mres )
{
  int res ;
  struct	TOKEN_STRUCT	token ;
  int     ptr ;
  int     i,cmdlen ;
  int     arglen ;
  unsigned char *cmdptr, *cmdline ;
  
  cmdlen=strlen(&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)]) ;
  cmdptr=NULL ;
  arglen=0 ;
  for( i=cmdlen-1 ; i>-1 ; i-- ){
    cmdptr=&mres->mem[seg(mres->GPR[3].rl+i)][lad(mres->GPR[3].rl+i)] ;
    if( *cmdptr=='/' ){
      cmdptr++ ;
      break ;
    }
  }
  arglen+=strlen(cmdptr)+1 ;
  
  /** ̎荞 **/
  for( i=0 ; ; i+=4 ){
    ptr =mres->mem[seg(mres->GPR[4].rl+i+0)][lad(mres->GPR[4].rl+i+0)]*0x01000000 ;
    ptr|=mres->mem[seg(mres->GPR[4].rl+i+1)][lad(mres->GPR[4].rl+i+1)]*0x00010000 ;
    ptr|=mres->mem[seg(mres->GPR[4].rl+i+2)][lad(mres->GPR[4].rl+i+2)]*0x00000100 ;
    ptr|=mres->mem[seg(mres->GPR[4].rl+i+3)][lad(mres->GPR[4].rl+i+3)]*0x00000001 ;
    if( ptr==0x00000000 ) break ;
    arglen+=strlen(&mres->mem[seg(ptr)][lad(ptr)])+1 ;
  }
  
  cmdline=malloc(arglen+2) ;
  cmdline[0]='\0' ;
  strcat( cmdline, cmdptr ) ;
  strcat( cmdline, " " ) ;
  for( i=0,arglen=0 ; ; i+=4 ){ //Ȃ񂩏璷....(^_^;;;
    ptr =mres->mem[seg(mres->GPR[4].rl+i+0)][lad(mres->GPR[4].rl+i+0)]*0x01000000 ;
    ptr|=mres->mem[seg(mres->GPR[4].rl+i+1)][lad(mres->GPR[4].rl+i+1)]*0x00010000 ;
    ptr|=mres->mem[seg(mres->GPR[4].rl+i+2)][lad(mres->GPR[4].rl+i+2)]*0x00000100 ;
    ptr|=mres->mem[seg(mres->GPR[4].rl+i+3)][lad(mres->GPR[4].rl+i+3)]*0x00000001 ;
    if( ptr==0x00000000 ) break ;
    strcat( cmdline, &mres->mem[seg(ptr)][lad(ptr)] ) ;
    strcat( cmdline, " " ) ;
  }
  get_token( cmdline , &token ) ;
  
  init_regs( mres ) ;
  mres->heap_top = default_heaptop ;
  mres->heap_size= default_heapsize ;
  mres->heap_cur = 0 ;
  mres->pc       = default_exec_start ;
  mres->GPR[1].rl= mres->mem_size[TEXT_SEG_TOP] - default_stack_top_offset ;
  
  res=elf_load(  mres, cmdptr ) ;
  if( res != NORMAL_EXIT ) return( res ) ;
  sim_setarg( mres, &token, 0 ) ;
  if( res != NORMAL_EXIT ) return( res ) ;
  do{
    int i ;
    int leng ;
    for( i=0 ; i<PNAME_LEN ; i++ ) mres->pname[i]='\0' ;
    leng=strlen(cmdline)+1 ;
    if( leng>=PNAME_LEN ) leng=PNAME_LEN ;
    strncpy( mres->pname, cmdline, leng ) ;
  } while(0) ;
  free( cmdline ) ;
  
  return(NORMAL_EXIT) ;
}
