/**********************************************************************
  traceR}h
  $Id: trace_cmd.c,v 1.4 2002/11/03 03:57:37 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"

int trace_cmd( struct TOKEN_STRUCT *tk_pt , int mode )
{
static unsigned char *msg[]={"Trace OFF","Trace PC","Trace GPR and others",
                             "Trace all Registers"} ;

  if( tk_pt->pt[1]==NULL ){
    SYSMSG("Current tracing state=%s\n",msg[trace_stat.msg_type] ) ;
    return(NORMAL_EXIT) ;
  }
  if(       strcmp(tk_pt->pt[1],"pc" )==0 ){
    trace_stat.msg_type  =TRACE_PC  ;
    trace_stat.print_type=PRINT_NON ;
  }else if( strcmp(tk_pt->pt[1],"gpr")==0 ){
    trace_stat.msg_type  =TRACE_GRP ;
    trace_stat.print_type=(PRINT_CRS|PRINT_GPRS) ;
  }else if( strcmp(tk_pt->pt[1],"all")==0 ){
    trace_stat.msg_type  =TRACE_ALL ;
    trace_stat.print_type=(PRINT_CRS|PRINT_GPRS|PRINT_FPRS) ;
  }else if( strcmp(tk_pt->pt[1],"off")==0 ){
    trace_stat.msg_type  =TRACE_OFF ;
    trace_stat.print_type=PRINT_NON ;
  }else{
    SYSMSG("Invalid argument %s\n",tk_pt->pt[1] ) ;
  }
  
  return(NORMAL_EXIT) ;
}

